<template lang="html">
  <div class="game-table-box">
    <div class="rulet-block">
      <div  class="img-rulet">
        <img ref="rulet_circle" src="../assets/img/home/rulet_img2.png" alt="#">
      </div>
    </div>
    <div class="table-block">

      <div class="ui-button">
        <button @click="show = !show" type="button" name="button">{{title}}</button>

      </div>
      <span>{{ bets }}</span>
      <button @click="getTest" type="button" name="button">TEST</button>
      <button @click="methodHereGet" type="button" name="button">TEST HERE</button>
      <button @click="betMassive" type="button" name="button">POST BETS</button>
      <div v-show="show" class="history-wins">
        <div class="head-table">
          <p>{{ titleTable }}</p>
          <div class="close-button">
            <button @click="show = !show" type="button" name="button"></button>
          </div>
        </div>
        <ul>
          <li v-if="tableItem.userName.length" v-for="(tableItem, key) in historyTable" :key="key" class="">
            <p @clicked="onChildClick">
              <span >{{ tableItem.userName }}</span>
              <span>{{ tableItem.typeCurrency }}{{ tableItem.amountBet }}</span>
            </p>
          </li>
          <li v-else class="empty-list-item"></li>
        </ul>
      </div>
      <div class="img-table">
        <div class="result-block">
          <ui-result-area
          :title="title"
          ></ui-result-area>
        </div>
        <div class="bet-block">
          <ui-oval-bet></ui-oval-bet>
          <ui-bet-table bets="bets"></ui-bet-table>
        </div>
        <div class="value-block">
          <ui-bet-chips></ui-bet-chips>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';
// window.Pusher = require('pusher-js');




export default {
  computed: {
    ...mapGetters('User', [
        'getBets'
    ])
  },
  mounted() {
    // window.Echo.channel('common')
    //   .listen('Test', (e) => {
    //     console.log('test');
    //   });
    // if (!this.joinedUsers.hasOwnProperty(user.id)) {
    //     this.joinedUsers[user.id] = true;
    //     console.log(user.id + "in");
    // }

    this.socket = window.Echo.join(`room.1`)
      .here((users) => {
         // this.joinedUsers.push(user)
         console.log(users)
      })
      .joining((user) => {
        this.joinedUsers.push(user)
        if (this.joinedUsers.length > 0) {
          this.getTest().then(() => {
          })
          console.log("1 user")
        }
        console.log(this.joinedUsers)
        // setTimeout(()=>{
        //   if (this.joinedUsers.length > 0 ) {
        //     this.$refs.rulet_circle.style.transform = "rotate(360deg)";
        //     this.$refs.rulet_circle.style.transition = "all 10s ease";
        //   }
        // },3000);
        // console.log(this.joinedUsers);
        // добавлять юзера в массив как, кто-то зайдет
      })
      .leaving((user) => {
        // delete this.joinedUsers[user.id];
        const index = this.joinedUsers.indexOf(user);
        this.joinedUsers.splice(index, 1);

        // console.log(this.joinedUsers);
      })
      .listen('Finish', (e) => {
        this.roomOne(this.getBets).then(() => {
        })
        console.log(e);
      });

  },
  methods: {
    betMassive () {
      this.roomOne(this.getBets).then(() => {
      })
    },
    methodHereGet(users){
       this.socket.join(`room.1`).here((users) => {
          // this.joinedUsers.push(user)
       });
       console.log('test')
    },
    onChildClick() {
      this.tableItem.value = 1;
      console.log('wo take')
    },

    getTest() {
      this.getTest().then(() => {
        console.log('getTEST')
      })
    },
    // roomOne(){
    //   this.roomOne().then(() => {
    //     console.log('bet test')
    //   })
    // },
    ...mapActions('User', [
        'getTest',
        'roomOne',
        'setBets'
      ]
    )
  },
  data() {
    return {
      show: false,
      title: 'Игроки',
      titleTable: 'История выигрышей',
      joinedUsers: [],
      users: [],
      // values: {
      //   bets: {
      //     split_1: 10,
      //     split_2: 20
      //   },
      //   nameRoom: 'light'
      // },
      buttons: [
        {
          title: 'Игроки'
        }
      ],
      historyTable: [
        {
          value: 0,
          userName: 'Алик Цукерман',
          amountBet: '2.00',
          typeCurrency: '$'
        },
        {
          userName: 'Алик Борман',
          amountBet: '2.509.00',
          typeCurrency: '$'
        },
        {
          userName: 'Алик Цука',
          amountBet: '3.100.00',
          typeCurrency: '$'
        },
        {
          userName: '',
          amountBet: '',
          typeCurrency: ''
        },
        {
          userName: '',
          amountBet: '',
          typeCurrency: ''
        },
        {
          userName: '',
          amountBet: '',
          typeCurrency: ''
        },
        {
          userName: '',
          amountBet: '',
          typeCurrency: ''
        },
        {
          userName: '',
          amountBet: '',
          typeCurrency: ''
        }
      ]
    }
  }

}
</script>

<style lang="scss" scoped>
  .history-wins {
    position: absolute;
    top: 40px;

    height: 37%;
    width: 20%;

    background-color: white;
    border: 1px solid #7E7E7E;
    border-radius: 5px;

    margin-left: 22px;
    .head-table {
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding-right: 20px;
      background: #EEF8FD;
      p {
        width: 100%;
        text-align: center;

        font-weight: bold;
        font-family: sans-serif;
        font-size: 15px;
      }
    }
    ul {
      list-style-type: none;
      counter-reset: item;
      margin: 0;
      padding: 0;


      overflow: hidden;
      li::before {
        content: counter(item) ') ';
        counter-increment: item;
      }
      .empty-list-item::before {
        content: '';
      }
      .empty-list-item {
        padding: 18px 30px;
      }
      li {
        padding: 10px 30px;

        border-bottom: 1px solid #7E7E7E;

        display: flex;
        p {
          margin: 0;
          width: 100%;
          display: flex;
          justify-content: space-between;
          margin-left: 5px;
        }
      }
    }
    .close-button {
      button {
        background-image: url(../assets/img/table/close-button_history.svg);
        background-position: center;

        border: none;

        width: 20px;
        height: 20px;

        outline: none;
      }
    }
  }
  .game-table-box {
    position: fixed;

    background-image: url(../assets/img/home/bg-game-table.svg);
    background-position: center;
    background-size: cover;

    z-index: 1;

    width: 100%;
    height: 100%;


    display: flex;
    flex-direction: column;
    justify-content: space-between;

    .rulet-block {
      display: flex;
      justify-content: center;

      width: 100%;

      position: relative;
      .img-rulet {
        width: 100%;
        height: 470px;

        // background-image: url(../assets/img/home/img-rulet.svg);
        // background-size: contain;
        // background-repeat: no-repeat;

        text-align: center;

        position: absolute;
        top: 30px;
        left: 0;
        right: 0;
        bottom: 0;
        margin: 0 auto;
        z-index: 1;

        transition: 8s all ease;
        img:hover {
          // transition: 5s all ease;
          //
          // transform: rotate(360deg);
        }
      }
    }
    .table-block {
        display: flex;
        justify-content: center;
        flex-direction: column;

        padding: 0 130px;

        z-index: 1;
      .img-table {
        width: 100%;
        height: 570px;

        background-image: url(../assets/img/home/table-game.svg);
        background-size: contain;
        background-repeat: no-repeat;

        display: flex;
        justify-content: center;
        .result-block {
          width: 18%
        }
        .bet-block {
          width: 60%;

          display: flex;
          flex-direction: column;
          justify-content: flex-end;
        }
        .value-block {
          width: 18%;
        }
      }
    }
  }

  .ui-button {
      position: relative;

      margin-left: 22px;

      width: 160px;
      height: 67px;

      font-weight: bold;
      display: flex;
      justify-content: center;
      align-items: center;

      background-image: url(../assets/img/home/bg-button.png);
      background-position: center;
      background-size: cover;
      background-repeat: no-repeat;

      button {
          outline: none;
          cursor: pointer;

          font-family: sans-serif;
          font-size: 19px;
          font-weight: bold;
          text-shadow: 0px -1px 1px #adadad;
          text-transform: uppercase;
          color: #6B3215;

          width: 100%;
          height: 100%;
          border: none;
          background-color: transparent;

          transition: .3s all ease;

      }
    button:hover {
      color: #B30000;

      transition: .3s all ease;
    }
  }
</style>
